=== debian/changelog ===
ros-eloquent-fastrtps (1.9.3-2bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Tue, 18 Feb 2020 17:22:14 -0000
